<%-- $Id: edit_annotationtype.jsp 4889 2009-04-06 12:52:39Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2005 Nicklas Nordborg
	Copyright (C) 2006 Jari Hkkinen, Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------


	@author Nicklas
	@version 2.0
--%>
<%@ page session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.Type"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.Include"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.AnnotationType"
	import="net.sf.basedb.core.AnnotationTypeCategory"
	import="net.sf.basedb.core.Quantity"
	import="net.sf.basedb.core.Unit"
	import="net.sf.basedb.core.SystemItems"
	import="net.sf.basedb.core.Metadata"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.ItemResultList"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.util.formatter.Formatter"
	import="net.sf.basedb.clients.web.formatter.FormatterFactory"
	import="net.sf.basedb.clients.web.formatter.FormatterSettings"
	import="java.util.Date"
	import="java.util.Set"
	import="java.util.List"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%
final Item itemType = Item.ANNOTATIONTYPE;
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, null, null);
final int itemId = cc.getId();
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final DbControl dc = sc.newDbControl();
try
{
	String title = null;
	AnnotationType annotationType = null;
	ItemQuery<AnnotationTypeCategory> categoryQuery = null;
	ItemQuery<Unit> unitQuery = null;
	Type valueType = null;
	boolean readCurrentQuantity = true;
	int currentQuantityId = 0;
	boolean readCurrentUnit = true;
	int currentUnitId = 0;

	if (itemId == 0)
	{
		title = "Create annotation type";
		valueType = Type.valueOf(request.getParameter("value_type"));
		if (valueType.isNumerical()) unitQuery = Unit.getQuery();
		
		int recentQuantityId = Values.getInt(cc.getRecent(Item.QUANTITY.name(), 0));
		currentQuantityId = Values.getInt(cc.getPropertyValue("quantity"), recentQuantityId);

		if (cc.getPropertyFilter("defaultUnit.name") != null)
		{
			Unit currentUnit = Base.getFirstMatching(dc, Unit.getQuery(), "name", cc.getPropertyFilter("defaultUnit.name"));
			if (currentUnit != null) currentUnitId = currentUnit.getId();
		}
		if (currentUnitId == 0) currentUnitId = Values.getInt(cc.getRecent(Item.UNIT.name(), 0));
		cc.removeObject("item");
	}
	else
	{
		annotationType = AnnotationType.getById(dc, itemId);
		annotationType.checkPermission(Permission.WRITE);
		valueType = annotationType.getValueType();
		cc.setObject("item", annotationType);
		title = "Edit annotation type -- " + HTML.encodeTags(annotationType.getName());
		categoryQuery = annotationType.getCategories();
		categoryQuery.include(Include.ALL);
		categoryQuery.order(Orders.asc(Hql.property("name")));
		try
		{
			if (annotationType.getValueType().isNumerical())
			{
				Quantity quantity = annotationType.getQuantity();
				if (quantity != null) 
				{
					currentQuantityId = quantity.getId();
					unitQuery = quantity.getUnits();
				}
				else
				{
					unitQuery = Unit.getQuery();
				}
				Unit unit = annotationType.getDefaultUnit();
				if (unit != null) currentUnitId = unit.getId();
			}
		}
		catch (PermissionDeniedException ex)
		{
			readCurrentQuantity = false;
			readCurrentUnit = false;
		}
	}

	if (unitQuery != null)
	{
		unitQuery.include(Include.ALL);
		unitQuery.order(Orders.asc(Hql.property("quantity.name")));
		unitQuery.order(Orders.asc(Hql.property("referenceFactor")));
		unitQuery.order(Orders.asc(Hql.property("name")));
	}
	
	final String clazz = "class=\"text\"";
	final String requiredClazz = "class=\"text required\"";
	Formatter<Date> dateFormatter = FormatterFactory.getDateFormatter(sc);
	String dateFormat = FormatterSettings.getDateFormat(sc);
	String jsDateFormat = HTML.javaScriptEncode(dateFormat);
	String htmlDateFormat = HTML.encodeTags(dateFormat);
	%>
	<base:page type="popup" title="<%=title%>">
	<base:head scripts="tabcontrol.js,linkitems.js,units.js" styles="tabcontrol.css">
		<script language="JavaScript">
		// Validate the "Annotation type" tab
		function validateAnnotationType()
		{
			var frm = document.forms['annotationType'];
			if (Main.trimString(frm.name.value) == '')
			{
				alert("You must enter a name");
				frm.name.focus();
				return false;
			}
			return true;
		}
		
		function validateOptions()
		{
			return true;
		}
		
		function validateItemTypes()
		{
			return true;
		}

		function validateUnits()
		{
			return true;
		}
		
		function validateCategories()
		{
			return true;
		}

		// Submit the form
		function saveSettings()
		{
			var frm = document.forms['annotationType'];
			if (TabControl.validateActiveTab('settings'))
			{
				var enabled = frm.enabled;
				for (var i = 0; i < enabled.length; i++) // >
				{
					enabled.options[i].selected = true;
				}
				frm.addCategories.value = Link.getActionIds(1, 'C').join(',');
				frm.removeCategories.value = Link.getActionIds(-1, 'C').join(',');
				if (frm.addUsableUnits && frm.removeUsableUnits)
				{
					frm.addUsableUnits.value = Link.getActionIds(1, 'U').join(',');
					frm.removeUsableUnits.value = Link.getActionIds(-1, 'U').join(',');
				}
				frm.submit();
			}
		}
		
		function init()
		{
			<%
			if (annotationType == null)
			{
				%>
				var frm = document.forms['annotationType'];
				frm.name.focus();
				frm.name.select();
				<%
			}
			%>
			initItemTypes();
			initCategories();
			initUnits();
			interfaceOnClick();
		}

		function initUnits()
		{
			var frm = document.forms['annotationType'];
			var quantityList = frm.quantity_id;
			var unitList = frm.unit_id;
			var quantity;
			<%
			if (unitQuery != null)
			{
				List<Unit> units = unitQuery.list(dc);
				Quantity prevQuantity = null;
				for (Unit unit : units)
				{
					Quantity quantity = unit.getQuantity();
					if (!quantity.equals(prevQuantity))
					{
						%>
						quantity = new Quantity(<%=quantity.getId()%>, '<%=HTML.javaScriptEncode(quantity.getName())%>');
						<%
						prevQuantity = quantity;
					}
					%>
					quantity.addUnit(<%=unit.getId()%>, '<%=HTML.javaScriptEncode(unit.getName())%>', '<%=HTML.javaScriptEncode(unit.getDisplaySymbol())%>');
					<%
				}
			}
			%>
			if (quantityList && unitList)
			{
				Quantities.populateLists(quantityList, unitList, <%=currentQuantityId%>, <%=currentUnitId%>);
				Quantities.updateUnitsList(quantityList[quantityList.selectedIndex].quantity, frm.allUnits);
				var usableUnits = new Array();
				<%
				if (annotationType != null)
				{
					ItemQuery<Unit> usableQuery = annotationType.getUsableUnits();
					usableQuery.include(Include.ALL);
					usableQuery.order(Orders.asc(Hql.property("referenceFactor")));
					usableQuery.order(Orders.asc(Hql.property("name")));
					
					ItemResultList<Unit> usableUnits = usableQuery.list(dc);
					for (Unit u : usableUnits)
					{
						%>
						usableUnits['ID<%=u.getId()%>'] = true;
						<%
					}
				}
				%>
				addToUsableUnits(usableUnits);
			}
		}
		
		function quantityOnChange()
		{
			var frm = document.forms['annotationType'];
			var quantityList = frm.quantity_id;
			var unitList = frm.unit_id;
			var quantity = quantityList[quantityList.selectedIndex].quantity;
			Quantities.updateUnitsList(quantity, unitList, <%=currentUnitId%>);
			Quantities.updateUnitsList(quantity, frm.allUnits);
		}

		function addToUsableUnits(usableUnits)
		{
			var frm = document.forms['annotationType'];
			for (var i = 0; i < frm.allUnits.length; i++)
			{
				var option = frm.allUnits[i];
				if (option.selected || (usableUnits && usableUnits['ID'+option.value]))
				{
					addUsableUnit(option.value, option.text, usableUnits);
					frm.allUnits[i--] = null;
				}
			}
		}

		function addUsableUnit(unitId, name, asNew)
		{
			var item = Link.getItem('U', unitId);
			if (!item) item = new Item('U', unitId, name);
			if (asNew)
			{
				Link.addNewItem(document.forms['annotationType'].usableUnits, item);
			}
			else
			{
				Link.addItem(document.forms['annotationType'].usableUnits, item);
			}
		}
		function removeFromUsableUnits()
		{
			var frm = document.forms['annotationType'];
			Link.removeSelected(frm.usableUnits, frm.allUnits);
		}
		
		function initItemTypes()
		{
			var frm = document.forms['annotationType'];
			var enabled = frm.enabled;
			var disabled = frm.disabled;
			<%
			Set<Item> items = Metadata.getAnnotatableItems();
			int itemCode = Values.getInt(cc.getPropertyValue("@itemTypes"), -1);
			for (Item item : items)
			{
				%>
				var option = new Option('<%=item.toString()%>', '<%=item.name()%>');
				Forms.addListOption(<%=(annotationType == null && itemCode == item.getValue()) || 
					(annotationType != null && annotationType.isEnabledForItem(item)) ? "enabled" : "disabled"%>, -1, option);
				<%
			}
			%>
		}
		
		function initCategories()
		{
			var categories = document.forms['annotationType'].categories;
			<%
			if (categoryQuery != null)
			{
				ItemResultList<AnnotationTypeCategory> categories = categoryQuery.list(dc);
				for (AnnotationTypeCategory category : categories)
				{
					%>
					Link.addNewItem(categories, new Item('C', <%=category.getId()%>, '<%=HTML.javaScriptEncode(category.getName())%>'));
					<%
				}
			}
			%>
		}
		function addCategoriesOnClick()
		{
			var categories = Link.getListIds(document.forms['annotationType'].categories, 'C');
			var url = '../annotationtypecategories/index.jsp?ID=<%=ID%>&cmd=UpdateContext&mode=selectmultiple&callback=addCategoryCallback';
			url += '&exclude='+categories.join(',');
			Main.openPopup(url, 'AddCategories', 1000, 700);
		}
		
		function addCategoryCallback(categoryId, name)
		{
			var item = Link.getItem('C', categoryId);
			if (!item) item = new Item('C', categoryId, name);
			Link.addItem(document.forms['annotationType'].categories, item);
		}
		function removeOnClick()
		{
			Link.removeSelected(document.forms['annotationType'].categories);
		}
		
		// Moves all selected items in list1 to list2
		function moveBetween(list1, list2)
		{
			var moved = 0;
			for(i=0; i < list1.options.length; i++) // >
			{
				if (list1.options[i].selected)
				{
					moved++;
					list2.options[list2.options.length] = new Option(list1.options[i].text, list1.options[i].value, false, true);
					list1.options[i] = null;
					i--;
				}
			}
		}
		
		function interfaceOnClick()
		{
			var frm = document.forms['annotationType'];
			if (frm['interface'])
			{
				var isEnum = Forms.getCheckedRadio(frm['interface']).value != 'box';
				if (frm.minValue) frm.minValue.disabled = isEnum;
				if (frm.maxValue) frm.maxValue.disabled = isEnum;
				if (frm.width) frm.width.disabled = isEnum;
				if (frm.maxLength) frm.maxLength.disabled = isEnum;
				if (frm.values) frm.values.disabled = !isEnum;
			}
		}
		</script>
	</base:head>
	<base:body onload="init()">
		<p>
		<form action="index.jsp?ID=<%=ID%>" method="post" name="annotationType" onsubmit="return false;">
		<input type="hidden" name="cmd" value="UpdateItem">
		<input type="hidden" name="value_type" value="<%=valueType.name()%>">

		<h3 class="docked"><%=title%> <base:help tabcontrol="settings" /></h3>
		<t:tabcontrol id="settings" contentstyle="<%="height: "+(int)(scale*300)+"px;"%>" 
			position="bottom" remember="<%=annotationType != null%>">
		<t:tab id="info" title="Annotation type" validate="validateAnnotationType()" helpid="annotationtype.edit">
			<table class="form" cellspacing=0>
			<tr>
				<td class="prompt">Value type</td>
				<td><%=valueType%></td>
			</tr>
			<tr>
				<td class="prompt">Name</td>
				<td><input <%=requiredClazz%> type="text" name="name" 
					value="<%=HTML.encodeTags(annotationType == null ? 
					Values.getString(cc.getPropertyValue("name"), "New "+valueType+" annotation type") : annotationType.getName())%>" 
					size="40" maxlength="<%=AnnotationType.MAX_NAME_LENGTH%>"></td>
			</tr>
			<tr>
				<td class="prompt">External ID</td>
				<td><input <%=clazz%> type="text" name="external_id" 
					value="<%=HTML.encodeTags(annotationType == null ? 
						Values.getString(cc.getPropertyValue("externalId"), "") : annotationType.getExternalId())%>" 
					size="40" maxlength="<%=AnnotationType.MAX_EXTERNAL_ID_LENGTH%>"></td>
			</tr>
			<tr>
				<td class="prompt">Multiplicity</td>
				<td><input <%=clazz%> type="text" name="multiplicity" 
					value="<%=annotationType == null ? Values.getString(cc.getPropertyValue("multiplicity"), "1") : 
						Integer.toString(annotationType.getMultiplicity())%>" 
					size="12" maxlength="10" onkeypress="return Numbers.integerOnly(event)">
					0 or empty = unlimited
					</td>
			</tr>
			<tr valign="top">
				<td class="prompt">Default value</td>
				<td>
					<%
					String defaultValue = annotationType == null ? cc.getPropertyValue("defaultValue") : annotationType.getDefaultValue();
					if (valueType == Type.INT || valueType == Type.LONG)
					{
						%>
						<input <%=clazz%> type="text" name="defaultValue" 
							value="<%=HTML.encodeTags(defaultValue)%>" 
							size="20" maxlength="20" onkeypress="return Numbers.integerOnly(event)">
						<%
					}
					else if (valueType == Type.FLOAT || valueType == Type.DOUBLE)
					{
						%>
						<input <%=clazz%> type="text" name="defaultValue" 
							value="<%=HTML.encodeTags(defaultValue)%>" 
							size="20" maxlength="20" onkeypress="return Numbers.numberOnly(event)">
						<%
					}
					else if (valueType == Type.BOOLEAN)
					{
						boolean booleanDefaultValue = Values.getBoolean(defaultValue);
						%>
						<input type="radio" name="defaultValue" value="true" 
							<%=booleanDefaultValue ? "checked" : ""%>
						>true
						<input type="radio" name="defaultValue" value="false" 
							<%=booleanDefaultValue ? "" : "checked"%>
						>false
						<%
					}
					else if (valueType == Type.DATE)
					{
						%>
						<table border="0" cellspacing="0" cellpadding="0">
						<tr>
						<td>
							<input <%=clazz%> type="text" name="defaultValue" 
								value="<%=HTML.encodeTags(defaultValue)%>" 
								size="20" maxlength="20 "title="Enter date in format: <%=htmlDateFormat%>">&nbsp;
						</td>
						<td>
							<base:button 
								onclick="<%="Dates.selectDate('Default value', 'annotationType', 'defaultValue', null, '"+jsDateFormat+"')"%>" 
								image="calendar.png"
								title="Calendar&hellip;" 
								tooltip="Select a date from a calendar" 
							/>
						</td>
						</tr>
						</table>
						<%
					}
					else if (valueType == Type.STRING)
					{
						%>
						<input <%=clazz%> type="text" name="defaultValue" 
							value="<%=HTML.encodeTags(defaultValue)%>" 
							size="40" maxlength="<%=AnnotationType.MAX_DEFAULT_VALUE_LENGTH%>">
					<%
					}
					else if (valueType == Type.TEXT)
					{
						%>
						<textarea <%=clazz%> rows="4" cols="40" name="defaultValue" 
							wrap="virtual"><%=HTML.encodeTags(defaultValue)%></textarea>
						<a href="javascript:Main.zoom('Default value', 'annotationType', 'defaultValue')" 
							title="Edit in larger window"><base:icon image="zoom.gif" /></a>
						<%
					}
					%>
				</td>
			</tr>
			<tr>
				<td class="prompt">Required for MIAME</td>
				<td><input type="checkbox" name="required_for_miame" value="1" 
					<%=(annotationType != null && annotationType.isRequiredForMiame()) || 
						(annotationType == null && Values.getBoolean(cc.getPropertyValue("requiredForMiame"))) ? "checked" : ""%>
			</tr>
			<tr>
				<td class="prompt">Protocol parameter</td>
				<td><input type="checkbox" name="is_protocol_parameter" value="1" 
					<%=(annotationType != null && annotationType.isProtocolParameter()) || 
						(annotationType == null && Values.getBoolean(cc.getPropertyValue("protocolParameter"))) ? "checked" : ""%>
			</tr>
			<tr valign=top>
				<td class="prompt">Description</td>
				<td nowrap>
					<textarea <%=clazz%> rows="4" cols="40" name="description" wrap="virtual"
						><%=HTML.encodeTags(annotationType == null ? cc.getPropertyValue("description") : annotationType.getDescription())%></textarea>
					<a href="javascript:Main.zoom('Description', 'annotationType', 'description')"
						title="Edit in larger window"><base:icon image="zoom.gif" /></a>
				</td>
			</tr>
			</table>
			<div align=right>&nbsp;<i><base:icon image="required.gif" /> = required information</i></div>
		</t:tab>
		
		<t:tab id="options" title="Options" validate="validateOptions()" helpid="annotationtype.edit.options">
			<table class="form" cellspacing=0>
			<%
			if (valueType == Type.INT || valueType == Type.LONG)
			{
				Long minValue = annotationType == null ? null : annotationType.getMinValueLong();
				Long maxValue = annotationType == null ? null : annotationType.getMaxValueLong();
				boolean isEnumeration = annotationType == null ? 
					Values.getBoolean(cc.getPropertyValue("enumeration")) : annotationType.isEnumeration();
				boolean displayAsList = annotationType == null ? false : annotationType.getDisplayAsList();
				%>
				<tr>
					<td class="prompt">Interface</td>
					<td>
						<input type="radio" name="interface" value="box"
							<%=!isEnumeration ? "checked" : ""%>
							onclick="interfaceOnClick()"
						>text box
						<input type="radio" name="interface" value="list" 
							<%=isEnumeration && displayAsList ? "checked" : ""%>
							onclick="interfaceOnClick()"
						>selection list
						<input type="radio" name="interface" value="buttons" 
							<%=isEnumeration && !displayAsList ? "checked" : ""%>
							onclick="interfaceOnClick()"
						>radiobuttons/checkboxes
					</td>
				</tr>
				<tr>
					<td class="prompt">Min value</td>
					<td>
						<input <%=clazz%> type="text" name="minValue" 
							value="<%=minValue == null ? "" : minValue.toString()%>" 
							size="20" maxlength="20" onkeypress="return Numbers.integerOnly(event)">
						empty = no limit
					</td>
				</tr>
				<tr>
					<td class="prompt">Max value</td>
					<td>
						<input <%=clazz%> type="text" name="maxValue" 
							value="<%=maxValue == null ? "" : maxValue.toString()%>" 
							size="20" maxlength="20" onkeypress="return Numbers.integerOnly(event)">
						empty = no limit
					</td>
				</tr>
				<tr>
					<td class="prompt">Input box width</td>
					<td>
						<input <%=clazz%> type="text" name="width" 
							value="<%=annotationType == null ? "" : annotationType.getWidth()%>" 
							size="12" maxlength="10" onkeypress="return Numbers.integerOnly(event)">
					</td>
				</tr>
				<tr valign="top">
					<td class="prompt">Values</td>
					<td nowrap>
						<%
						String values = annotationType == null ? "" : Values.getString(annotationType.getValues(), "\n", true);
						%>
						<textarea <%=clazz%> rows="10" cols="40" name="values" wrap="virtual"
							onkeypress="return Numbers.integerOnly(event)"><%=HTML.encodeTags(values)%></textarea>
						<a href="javascript:Main.zoom('Values', 'annotationtype', 'values')"
							title="Edit in larger window"><base:icon image="zoom.gif" /></a><br>
						One enumeration value per line
					</td>
				</tr>
				<%
			}
			else if (valueType == Type.FLOAT || valueType == Type.DOUBLE)
			{
				Double minValue = annotationType == null ? null : annotationType.getMinValueDouble();
				Double maxValue = annotationType == null ? null : annotationType.getMaxValueDouble();
				boolean isEnumeration = annotationType == null ? 
					Values.getBoolean(cc.getPropertyValue("enumeration")) : annotationType.isEnumeration();
				boolean displayAsList = annotationType == null ? false : annotationType.getDisplayAsList();
				%>
				<tr>
					<td class="prompt">Interface</td>
					<td>
						<input type="radio" name="interface" value="box"
							<%=!isEnumeration ? "checked" : ""%>
							onclick="interfaceOnClick()"
						>text box
						<input type="radio" name="interface" value="list" 
							<%=isEnumeration && displayAsList ? "checked" : ""%>
							onclick="interfaceOnClick()"
						>selection list
						<input type="radio" name="interface" value="buttons" 
							<%=isEnumeration && !displayAsList ? "checked" : ""%>
							onclick="interfaceOnClick()"
						>radiobuttons/checkboxes
					</td>
				</tr>
				<tr>
					<td class="prompt">Min value</td>
					<td>
						<input <%=clazz%> type="text" name="minValue" 
							value="<%=minValue == null ? "" : minValue.toString()%>" 
							size="20" maxlength="20" onkeypress="return Numbers.numberOnly(event)">
						empty = no limit
					</td>
				</tr>
				<tr>
					<td class="prompt">Max value</td>
					<td>
						<input <%=clazz%> type="text" name="maxValue" 
							value="<%=maxValue == null ? "" : maxValue.toString()%>" 
							size="20" maxlength="20" onkeypress="return Numbers.numberOnly(event)">
						empty = no limit
					</td>
				</tr>
				<tr>
					<td class="prompt">Input box width</td>
					<td>
						<input <%=clazz%> type="text" name="width" 
							value="<%=annotationType == null ? "" : annotationType.getWidth()%>" 
							size="12" maxlength="10" onkeypress="return Numbers.integerOnly(event)">
					</td>
				</tr>
				<tr valign="top">
					<td class="prompt">Values</td>
					<td nowrap>
						<%
						String values = annotationType == null ? "" : Values.getString(annotationType.getValues(), "\n", true);
						%>
						<textarea <%=clazz%> rows="10" cols="40" name="values" wrap="virtual"
							onkeypress="return Numbers.numberOnly(event)"><%=HTML.encodeTags(values)%></textarea>
						<a href="javascript:Main.zoom('Values', 'annotationtype', 'values')" 
							title="Edit in larger window"><base:icon image="zoom.gif" /></a><br>
						One enumeration value per line
					</td>
				</tr>
				<%
			}
			else if (valueType == Type.BOOLEAN)
			{
				%>
				No options for this type.
				<%
			}
			else if (valueType == Type.DATE)
			{
				boolean isEnumeration = annotationType == null ? 
					Values.getBoolean(cc.getPropertyValue("enumeration")) : annotationType.isEnumeration();
				boolean displayAsList = annotationType == null ? false : annotationType.getDisplayAsList();
				%>
				<tr>
					<td class="prompt">Interface</td>
					<td>
						<input type="radio" name="interface" value="box"
							<%=!isEnumeration ? "checked" : ""%>
							onclick="interfaceOnClick()"
						>text box
						<input type="radio" name="interface" value="list" 
							<%=isEnumeration && displayAsList ? "checked" : ""%>
							onclick="interfaceOnClick()"
						>selection list
						<input type="radio" name="interface" value="buttons" 
							<%=isEnumeration && !displayAsList ? "checked" : ""%>
							onclick="interfaceOnClick()"
						>radiobuttons/checkboxes
					</td>
				</tr>
				<tr>
					<td class="prompt">Input box width</td>
					<td>
						<input <%=clazz%> type="text" name="width" 
							value="<%=annotationType == null ? "" : annotationType.getWidth()%>" 
							size="12" maxlength="10" onkeypress="return Numbers.integerOnly(event)">
					</td>
				</tr>
				<tr valign="top">
					<td class="prompt">Values</td>
					<td nowrap>
						<%
						String values = annotationType == null ? "" : 
							Values.getString((List<Date>)annotationType.getValues(), "\n", true, dateFormatter);
						%>
						<textarea <%=clazz%> rows="10" cols="40" name="values" wrap="virtual"
							><%=HTML.encodeTags(values)%></textarea>
						<a href="javascript:Main.zoom('Values', 'annotationtype', 'values')" title="Edit in larger window"><base:icon image="zoom.gif" /></a><br>
						One date value (<%=htmlDateFormat%>) per line
					</td>
				</tr>
				<%
			}
			else if (valueType == Type.STRING)
			{
				Integer maxLength = annotationType == null ? null : annotationType.getMaxLength();
				boolean isEnumeration = annotationType == null ? 
					Values.getBoolean(cc.getPropertyValue("enumeration")) : annotationType.isEnumeration();
				boolean displayAsList = annotationType == null ? false : annotationType.getDisplayAsList();
				%>
				<tr>
					<td class="prompt">Interface</td>
					<td>
						<input type="radio" name="interface" value="box"
							<%=!isEnumeration ? "checked" : ""%>
							onclick="interfaceOnClick()"
						>text box
						<input type="radio" name="interface" value="list" 
							<%=isEnumeration && displayAsList ? "checked" : ""%>
							onclick="interfaceOnClick()"
						>selection list
						<input type="radio" name="interface" value="buttons" 
							<%=isEnumeration && !displayAsList ? "checked" : ""%>
							onclick="interfaceOnClick()"
						>radiobuttons/checkboxes
					</td>
				</tr>
				<tr>
					<td class="prompt">Max length</td>
					<td>
						<input <%=clazz%> type="text" name="maxLength" 
							value="<%=maxLength == null ? "" : maxLength.toString()%>" 
							size="12" maxlength="3" onkeypress="return Numbers.integerOnly(event)"> (1-255)
					</td>
				</tr>
				<tr>
					<td class="prompt">Input box width</td>
					<td>
						<input <%=clazz%> type="text" name="width" 
							value="<%=annotationType == null ? "" : annotationType.getWidth()%>" 
							size="12" maxlength="10" onkeypress="return Numbers.integerOnly(event)">
					</td>
				</tr>
				<tr valign="top">
					<td class="prompt">Values</td>
					<td nowrap>
						<%
						String values = annotationType == null ? "" : Values.getString(annotationType.getValues(), "\n", true);
						%>
						<textarea <%=clazz%> rows="10" cols="40" name="values" wrap="virtual"><%=HTML.encodeTags(values)%></textarea>
						<a href="javascript:Main.zoom('Values', 'annotationtype', 'values')" 
							title="Edit in larger window"><base:icon image="zoom.gif" /></a><br>
						One enumeration value per line
					</td>
				</tr>
				<%
			}
			else if (valueType == Type.TEXT)
			{
				%>
				<tr>
					<td class="prompt">Input box width</td>
					<td>
						<input <%=clazz%> type="text" name="width" 
							value="<%=annotationType == null ? "" : annotationType.getWidth()%>" 
							size="12" maxlength="10" onkeypress="return Numbers.integerOnly(event)">
					</td>
				</tr>
				<tr>
					<td class="prompt">Input box height</td>
					<td>
						<input <%=clazz%> type="text" name="width" 
							value="<%=annotationType == null ? "" : annotationType.getHeight()%>" 
							size="12" maxlength="10" onkeypress="return Numbers.integerOnly(event)">
					</td>
				</tr>
				<%
			}
			%>
			</table>
		</t:tab>
		
		<t:tab id="items" title="Item types" validate="validateItemTypes()" helpid="annotationtype.edit.items">
		<table border=0 cellspacing=0 cellpadding=2>
		<tr>
			<td>
				<b>Enabled for</b><br>
				<select name="enabled" multiple size="14" style="width: 12em;"
					ondblclick="moveBetween(document.forms['annotationType'].enabled, document.forms['annotationType'].disabled)">
				</select>
			</td>
	
			<td>
			   <br>
				<base:button
					onclick="moveBetween(document.forms['annotationType'].disabled, document.forms['annotationType'].enabled)" 
					title="<img src='../../images/move_left.gif' alt='' style='vertical-align: middle;'>" 
					tooltip="Enable the annotation type for the selected item(s)" 
				/><p>
				<base:button 
					onclick="moveBetween(document.forms['annotationType'].enabled, document.forms['annotationType'].disabled)" 
					title="<img src='../../images/move_right.gif' alt='' style='vertical-align: middle;'>" 
					tooltip="Disable the annotation type for the selected item(s)" 
				/>
				<br>
			</td>
	
			<td>
				<b>Disabled for</b><br>
				<select name="disabled" multiple size="14" style="width: 12em;" 
					ondblclick="moveBetween(document.forms['annotationType'].disabled, document.forms['annotationType'].enabled)">
				</select>
			</td>
		</tr>
		</table>
		</t:tab>
		
		<t:tab id="units" title="Units" validate="validateUnits()" 
			visible="<%=valueType.isNumerical()%>" helpid="annotationtype.edit.units">
		
			<table class="form" cellspacing="0">
			<tr valign="top">
				<td class="prompt">Quantity</td>
				<td>
					<select name="quantity_id" onchange="quantityOnChange()"
						<%=!readCurrentQuantity || (annotationType != null && currentQuantityId != 0) ? 
								"disabled readonly class=\"disabled\"" : "class=\"unchangeable\""%>>
						<option value="">- do not use units -
					</select>
				</td>
			</tr>
			<tr valign="top">
				<td class="prompt">Default unit</td>
				<td>
					<select name="unit_id" 
						<%=!readCurrentQuantity ? "disabled readonly class=\"disabled\"" : ""%>>
					</select>
				</td>
			</tr>
			</table>

			<base:note type="warning" style="background: #ffffd8;"  visible="<%=annotationType != null %>">
			Changing the default unit triggers a conversion of existing annotation values
			to the new unit. This may result in loss of precision due to rounding or 
			truncation.
			</base:note>

			<table class="form" cellspacing="0">
			<tr valign="top">
				<td class="prompt">Use units</td>
				<td></td>
				<td class="prompt">Do not use</td>
			</tr>
			<tr>
				<td>
					<select name="usableUnits" size="5" multiple style="width: 15em;" ondblclick="removeFromUsableUnits()">
					</select>
				</td>
				<td>
				   <br>
					<base:button
						onclick="addToUsableUnits()"
						title="<img src='../../images/move_left.gif' alt='' style='vertical-align: middle;'>" 
						tooltip="Enable the annotation type for the selected unit(s)" 
					/><p>
					<base:button 
						onclick="removeFromUsableUnits()"
						title="<img src='../../images/move_right.gif' alt='' style='vertical-align: middle;'>" 
						tooltip="Disable the annotation type for the selected unit(s)" 
					/>
					<br>
				</td>
				<td>
					<select name="allUnits" size="5" multiple style="width: 15em;" ondblclick="addToUsableUnits()">
					</select>
					<input type="hidden" name="removeUsableUnits" value="">
					<input type="hidden" name="addUsableUnits" value="">
				</td>
			</tr>
			</table>

			<div align=right>
				<i><base:icon image="unchangeable.gif" /> = can't be changed later</i>
			</div>

		</t:tab>

		<t:tab id="categories" title="Categories" validate="validateCategories()" 
			helpid="annotationtype.edit.categories">
			<table >
			<tr valign="top">
			<td>
				<b>Categories</b><br>
				<select name="categories" size="14" multiple 
					style="width: 15em;">
				</select>
				<input type="hidden" name="removeCategories" value="">
				<input type="hidden" name="addCategories" value="">
			</td>
			<td>
				<br>
				<table width="150">
				<tr><td><base:button 
					onclick="addCategoriesOnClick()" 
					title="Add&nbsp;categories&hellip;" 
					tooltip="Add categories to this annotation type"
					/></td></tr>
				<tr><td><base:button 
					onclick="removeOnClick()" 
					title="Remove" 
					tooltip="Remove the selected categories from this annotation type"
				/></td></tr>
				</table>
			</td>
			</tr>
			</table>
		</t:tab>
		
		</t:tabcontrol>

		<table align="center">
		<tr>
			<td width="50%"><base:button onclick="saveSettings()" title="Save" /></td>
			<td width="50%"><base:button onclick="window.close()" title="Cancel" /></td>
		</tr>
		</table>
		</form>
	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
%>
