<%-- $Id: settings.jsp 4889 2009-04-06 12:52:39Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2005 Nicklas Nordborg
	Copyright (C) 2006 Jari Hkkinen, Nicklas Nordborg
	Copyright (C) 2007 Martin Svensson

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
	@version 2.0
--%>
<%@ page session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.WebException"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.clients.web.util.HTML"
 	import="net.sf.basedb.util.extensions.ExtensionPoint"
	import="net.sf.basedb.util.extensions.Extension"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final String ID = sc.getId();
final float scale = Base.getScale(sc);
DbControl dc = null;
try
{
	dc = sc.newDbControl();
	ExtensionsControl ec = ExtensionsControl.get(dc);
	ec.checkPermission(Permission.WRITE);
	
	int autoInstall = ec.getAutoInstall();
	%>
	<base:page type="popup" title="Extension settings">
	<base:head scripts="tabcontrol.js" styles="tabcontrol.css">
		<script language="JavaScript">
		
		// Submit the form
		function saveSettings()
		{
			var frm = document.forms['settings'];
			if (TabControl.validateActiveTab('main'))
			{
				frm.submit();
			}
		}
		</script>
	</base:head>
	<base:body>
	<p>

	<form action="index.jsp?ID=<%=ID%>" method="post" name="settings" onsubmit="return false;">
	<input type=hidden name="cmd" value="SaveSettings">
	
	<h3 class="docked">Extension settings <base:help tabcontrol="main" /></h3>
	<t:tabcontrol id="main" 
		contentstyle="<%="height: "+(int)(scale*240)+"px;"%>" position="bottom" remember="false">
	
	<t:tab id="all" title="Settings" helpid="extensions.settings">
		<table class="form" cellspacing=0>
		<tr>
			<td class="prompt">Auto-installation interval</td>
			<td>
				<input type="text" class="text" name="autoInstall" 
					value="<%=autoInstall > 0 ? autoInstall : 0%>" > seconds<br> (0 = disabled)
			</td>
		</tr>
		</table>
	</t:tab>
	
	</t:tabcontrol>

	<p>
	<div align=center>
		<table align="center">
		<tr>
			<td width="50%"><base:button onclick="saveSettings();" title="Save" /></td>
			<td width="50%"><base:button onclick="window.close();" title="Cancel" /></td>
		</tr>
		</table>

	</div>
	</form>
	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
%>
