<%-- $Id: configure.jsp 4889 2009-04-06 12:52:39Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2005 Nicklas Nordborg
	Copyright (C) 2006 Jari Häkkinen, Nicklas Nordborg, Gregory Vincic
	Copyright (C) 2007 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	Configure the order and visibility of columns in a table of items.
	This page will use the TableColumn.getTableColumns(item) to retreive the
	list of all available columns for that item type and
	getSession().getSetting(item+".columns") to retreive a comma-separated
	list of the current order of visible columns.

	@param item The type of items in the table

	@author Nicklas
	@version 2.0
--%>
<%@ page session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.util.Enumeration"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.clients.web.Base"
	import="java.util.Set"
	import="java.util.TreeSet"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>

<%
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final String ID = sc.getId();
final Item itemType = Item.valueOf(request.getParameter("item_type"));
final String subContext = Values.getString(request.getParameter("subcontext"), "");
final String tableId = request.getParameter("table_id");
final String defaultColumns = request.getParameter("default");

%>
	<base:page type="popup" title="Set column order and visibility">
	<base:head>
		<script language="JavaScript">
		var tableId = '<%=tableId%>';

		// Initialise the visible and hidden column lists
		function initColumns(columns)
		{
			var frm = document.forms['columns'];
			var visible = frm.visible;
			var hidden = frm.hidden;
			visible.length = 0; 
			hidden.length = 0;  

			// The visibled columns (comma-separated)
			var allVisible = columns == 'all';
			var visibleCols = columns.split(',');

			// All column definitions
			var columnDefs = window.opener.Table.getColumnDefs(tableId);

			// Put all column in the hidden or visible list
			var toList = allVisible ? visible : hidden;
			for (var i = 0; i < columnDefs.length; i++) 
			{
				var col = columnDefs[i];
				if (!col.alwaysHide) addCol(toList, col);
			}
			
			// Move visible columns to the visible list
			if (!allVisible)
			{
				for (var i = 0; i < visibleCols.length; i++)
				{
					var colId = visibleCols[i];
					var col = columnDefs['id'+colId];
					for (var j = 0; j < hidden.length; j++)
					{
						if (hidden[j].value == colId)
						{
							addCol(visible, col);
							hidden[j] = null;
							j = hidden.length;
						}
					}
				}
				
				// Move columns that must be visible to the visible list
				for (var i = 0; i < hidden.length; i++)
				{
					var col = columnDefs['id'+hidden.options[i].value];
					if (col && col.alwaysShow)
					{
						addCol(visible, col);
						hidden[i] = null; 
						i--;
					}
				}
			}
		}
		
		function addCol(toList, col)
		{
			var option = new Option(col.title, col.id);
			if (col.alwaysShow)
			{
				option.style.fontWeight = 'bold';
				option.text = option.text+' ×';
			}
			toList[toList.length] = option;
		}

		// Moves all selected items in list1 to list2
		function moveBetween(list1, list2)
		{
			var moved = 0;
			var columnDefs = window.opener.Table.getColumnDefs(tableId);
			for(i=0; i < list1.options.length; i++) // >
			{
				if (list1.options[i].selected)
				{
					var col = columnDefs['id'+list1.options[i].value];
					if (col.alwaysShow)
					{
						alert("'" + col.title + "' must always be visible");
					}
					else
					{
						moved++;
						list2.options[list2.options.length] = new Option(list1.options[i].text, list1.options[i].value, false, true);
						list1.options[i] = null;
						i--;
					}
				}
			}
			if (moved > 0) clearPreset();
		}
		
		// Move all selected items in the list up or down
		function moveSelected(list, up)
		{
			var moved = Forms.moveListOptions(list, up);
			if (moved > 0) clearPreset();
		}
		
		// Sets the preset selection list to the first (empty) element
		function clearPreset()
		{
			var frm = document.forms['columns'];
			frm.presets.selectedIndex = 0;
		}
		
		// Update the settings according to the selection in the presets list
		function updateColumns()
		{
			var frm = document.forms['columns'];
			var presets = frm.presets;
			var columns = presets.options[presets.selectedIndex].value;
			if (columns == '') return;
			if (columns == '_default_') columns = '<%=defaultColumns%>';
			if (columns == '_current_') columns = window.opener.Table.getColumns('<%=tableId%>');
			if (columns == '_minimal_')
			{
				var columnDefs = window.opener.Table.getColumnDefs(tableId);
				var temp = new Array();
				for (var i = 0; i < columnDefs.length; i++) // >
				{
					var col = columnDefs[i];
					var option = new Option(col.title, col.id);
					if (col.alwaysShow) temp[temp.length] = col.id;
				}
				columns = temp.join(',');
			}
			initColumns(columns);
		}
		
		function savePresetAs()
		{
			var selected = getVisibleColumns();
			Main.openPopup('save_preset.jsp?ID=<%=ID%>&item_type=<%=itemType.name()%>&subcontext=<%=subContext%>&columns='+selected, 'SavePreset', 360, 200);
		}
		
		// Save the configuration to the parent window
		function saveColumns()
		{
			var selected = getVisibleColumns()
			window.opener.Table.setColumns('<%=tableId%>', selected);
			window.close();
		}
		
		// Get all visible columns as a comma-separated string
		function getVisibleColumns()
		{
			var list = document.forms['columns'].visible;
			var selected = '';
			for (var i = 0; i < list.options.length; i++)
			{
				if (i > 0) selected += ',';
				selected += list.options[i].value;
			}
			return selected;
		}
		</script>
	</base:head>
	<base:body onload="<%="initColumns(window.opener.Table.getColumns('"+tableId+"'))"%>">
		<form name="columns" onsubmit="return false;">
	
		<h3 class="docked">Set column order and visiblity <base:help helpid="columns.configure" /></h3>
		<div class="boxed" align="center">
		<table border=0 cellspacing=0 cellpadding=2 width="100%">
		<tr>
			<td style="vertical-align: middle">
				<br>
				<base:button
					onclick="moveSelected(document.forms['columns'].visible, false)" 
					title="<img src='../../images/move_up.gif' alt='' style='vertical-align: middle;'>" 
					tooltip="Move up" 
				/><p>
				<base:button 
					onclick="moveSelected(document.forms['columns'].visible, true)" 
					title="<img src='../../images/move_down.gif' alt='' style='vertical-align: middle;'>" 
					tooltip="Move down" 
				/>
				<br>
			</td>
	
			<td width="50%">
				<b>Visible columns</b><br>
				<select name="visible" multiple size="14" style="width: 100%;" 
					ondblclick="moveBetween(document.forms['columns'].visible, document.forms['columns'].hidden)">
				</select>
			</td>
	
			<td style="vertical-align: middle">
			   <br>
				<base:button
					onclick="moveBetween(document.forms['columns'].hidden, document.forms['columns'].visible)" 
					title="<img src='../../images/move_left.gif' alt='' style='vertical-align: middle;'>" 
					tooltip="Make the selected hidden column(s) visible" 
				/><p>
				<base:button 
					onclick="moveBetween(document.forms['columns'].visible, document.forms['columns'].hidden)" 
					title="<img src='../../images/move_right.gif' alt='' style='vertical-align: middle;'>" 
					tooltip="Make the selected visible column(s) hidden" 
				/>
				<br>
			</td>
	
			<td width="50%">
				<b>Hidden columns</b><br>
				<select name="hidden" multiple size="14" style="width: 100%;" 
					ondblclick="moveBetween(document.forms['columns'].hidden, document.forms['columns'].visible)">
				</select>
			</td>
		</tr>
		<tr>
			<td>&nbsp;</td>
			<td colspan="3">
				<div align="right">
					<b>×</b> = This column cannot be hidden
				</div>
				<center>
				<table>
				<tr>
				<td>
					<b>Presets</b><br>
					<select name="presets" onChange="updateColumns()">
						<option value="">-- predefined --
						<option value="all">All
						<option value="_minimal_">Required
						<option value="_current_">Current
						<%
						if (defaultColumns != null)
						{
							%>
							<option value="_default_">Default
							<%
						}
						%>
						<option value="">-- user defined --
						<%
						Enumeration<Integer, String> contexts = sc.getContextNames(itemType, subContext);
						for (int i = 0; i < contexts.size(); ++i)
						{
							ItemContext context = sc.getContext(contexts.getKey(i));
							if (context != null && !ItemContext.DEFAULT_NAME.equals(context.getName()))
							{
								String columns = context.getSetting("columns");
								%>
								<option value="<%=columns%>"><%=HTML.encodeTags(context.getName())%>
								<%
							}
						}
						%>
					</select>
					</td>
					<%
					if (request.getParameter("nosavedelete") == null)
					{
						%>
						<td><br><base:button onclick="savePresetAs();" title="Save as&hellip;" /></td>
						<%
					}
					%>
				</tr>
				</table>
				</center>
			</td>
		</tr>
		</table>
		</div>
		</form>
		<table align="center">
		<tr>
			<td width="50%"><base:button onclick="saveColumns();" title="Ok" /></td>
			<td width="50%"><base:button onclick="window.close();" title="Cancel" /></td>
		</tr>
		</table>
	</base:body>
	</base:page>

