<%-- $Id: merge_plates.jsp 4889 2009-04-06 12:52:39Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2005 Nicklas Nordborg
	Copyright (C) 2006 Jari Hkkinen, Nicklas Nordborg, Martin Svensson

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------


	@author Nicklas
	@version 2.0
--%>
<%@ page session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.Plate"
	import="net.sf.basedb.core.PlateType"
	import="net.sf.basedb.core.PlateMapping"
	import="net.sf.basedb.core.BaseException"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="java.util.List"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%
final Item itemType = Item.PLATE;
final SessionControl sc = Base.getExistingSessionControl(pageContext, Permission.CREATE, itemType);
final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, null, null);
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final DbControl dc = sc.newDbControl();
try
{
	String title = "Merge plates -- step 1 of 2 -- Select mapping";
	final String clazz = "class=\"text\"";
	final String requiredClazz = "class=\"text required\"";
	
	// Load recently used items
	List<PlateMapping> recentPlateMappings = (List<PlateMapping>)cc.getRecent(dc, Item.PLATEMAPPING);
	List<PlateType> recentPlateTypes = (List<PlateType>)cc.getRecent(dc, Item.PLATETYPE);
	%>

	<base:page type="popup" title="<%=title%>">
	<base:head>
		<script language="JavaScript">
		// Validate the entered information
		function validate()
		{
			var frm = document.forms['merge'];
			if (Main.trimString(frm.name.value) == '')
			{
				alert("You must enter a name");
				frm.name.focus();
				return false;
			}
			if (frm.platemapping_id[frm.platemapping_id.selectedIndex].value == '')
			{
				alert("You must select a plate mapping");
				return false;
			}
			if (frm.platetype_id[frm.platetype_id.selectedIndex].value == '')
			{
				alert("You must select a plate type");
				return false;
			}
			return true;
		}

		// Submit the form
		function nextStep()
		{
			var frm = document.forms['merge'];
			if (validate())
			{
				frm.submit();
			}
		}
		
		function selectPlateMappingOnClick()
		{
			var frm = document.forms['merge'];
			var url = '../platemappings/index.jsp?ID=<%=ID%>&mode=selectone&callback=setPlateMappingCallback';
			Main.openPopup(url, 'SelectPlateMapping', 1000, 700);
		}
		function setPlateMappingCallback(id, name)
		{
			var frm = document.forms['merge'];
			var list = frm.platemapping_id;
			if (list.length < 1 || list[0].value == '0') // >
			{
				Forms.addListOption(list, 0, new Option());
			}
			list[0].value = id;
			list[0].text = name;
			list.selectedIndex = 0;
		}

		function selectPlateTypeOnClick()
		{
			var frm = document.forms['merge'];
			var url = '../platetypes/index.jsp?ID=<%=ID%>&mode=selectone&callback=setPlateTypeCallback';
			Main.openPopup(url, 'SelectPlateType', 1000, 700);
		}
		function setPlateTypeCallback(id, name)
		{
			var frm = document.forms['merge'];
			var list = frm.platetype_id;
			if (list.length < 1 || list[0].value == '0') // >
			{
				Forms.addListOption(list, 0, new Option());
			}
			list[0].value = id;
			list[0].text = name;
			list.selectedIndex = 0;
		}
		</script>
	</base:head>
	<base:body>
		<p>
		<form action="merge_plates_2.jsp?ID=<%=ID%>" method="post" name="merge" onsubmit="return false;">

		<h3 class="docked"><%=title%> <base:help helpid="plates.merge.1" /></h3>
		<div class="boxed" style="<%="height: "+(int)(scale*280)+"px;"%>">
			<table class="form" cellspacing=0>
			<tr>
				<td class="prompt">Plate mapping</td>
				<td>
					<base:select 
						id="platemapping_id"
						clazz="selectionlist required"
						required="true"
						current="<%=null%>"
						recent="<%=recentPlateMappings%>"
						newitem="true"
						onselect="selectPlateMappingOnClick()"
					/>
				</td>
			</tr>
			<tr>
				<td class="prompt">Name</td>
				<td><input <%=requiredClazz%> type="text" name="name" value="New plate" 
					size="40" maxlength="<%=Plate.MAX_NAME_LENGTH%>"></td>
			</tr>
			<tr>
				<td class="prompt">Plate type</td>
				<td>
					<base:select 
						id="platetype_id"
						clazz="selectionlist required"
						required="true"
						current="<%=null%>"
						recent="<%=recentPlateTypes%>"
						newitem="true"
						onselect="selectPlateTypeOnClick()"
					/>
				</td>
			</tr>
			</table>
		</div>

		<table align="center">
		<tr>
			<td width="50%"><base:button onclick="nextStep()" title="Next" /></td>
			<td width="50%"><base:button onclick="window.close()" title="Cancel" /></td>
		</tr>
		</table>

		</form>
	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
%>
