<%-- $Id: view_bioassay.jsp 4889 2009-04-06 12:52:39Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2006 Jari Hkkinen, Nicklas Nordborg, Martin Svensson

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------


	@author Nicklas
	@version 2.0
--%>
<%@ page session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.Experiment"
	import="net.sf.basedb.core.BioAssaySet"
	import="net.sf.basedb.core.BioAssay"
	import="net.sf.basedb.core.RawBioAssay"
	import="net.sf.basedb.core.Annotatable"
	import="net.sf.basedb.core.AnnotationSet"
	import="net.sf.basedb.core.AnnotationType"
	import="net.sf.basedb.core.Annotation"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.ItemResultList"
	import="net.sf.basedb.core.Include"
	import="net.sf.basedb.core.BaseException"
	import="net.sf.basedb.core.PluginDefinition"
	import="net.sf.basedb.core.plugin.GuiContext"
	import="net.sf.basedb.core.plugin.Plugin"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.util.formatter.Formatter"
	import="net.sf.basedb.clients.web.formatter.FormatterFactory"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.PermissionUtil"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="net.sf.basedb.clients.web.extensions.JspContext"
	import="net.sf.basedb.clients.web.extensions.renderer.PrefixSuffixRenderer"
	import="net.sf.basedb.clients.web.extensions.toolbar.ToolbarUtil"
	import="net.sf.basedb.util.extensions.ExtensionsInvoker"
	import="net.sf.basedb.util.Values"
	import="java.util.Map"
	import="java.util.List"
	import="java.util.HashMap"
	import="java.util.LinkedList"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%@ taglib prefix="p" uri="/WEB-INF/path.tld" %>
<%@ taglib prefix="tbl" uri="/WEB-INF/table.tld" %>
<%@ taglib prefix="ext" uri="/WEB-INF/extensions.tld" %>
<%!
	private static final Item itemType = Item.BIOASSAY;
	private static final GuiContext guiContext = new GuiContext(itemType, GuiContext.Type.ITEM);
%>
<%
final Item itemType = Item.BIOASSAY;
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, null, null);
final int itemId = cc.getId();
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final String tabId = Values.getString(request.getParameter("tab"), "properties");
final DbControl dc = sc.newDbControl();
try
{
	BioAssay bioAssay = BioAssay.getById(dc, itemId);
	final boolean hasDbSpots = bioAssay.getNumSpots() > 0;
	BioAssaySet bioAssaySet = bioAssay.getBioAssaySet();
	Experiment experiment = bioAssay.getExperiment();
	String title = null;
	final boolean writePermission = bioAssay.hasPermission(Permission.WRITE);
	Map<Plugin.MainType, Integer> pluginCount = PluginDefinition.countPlugins(dc, guiContext);
	JspContext jspContext = ExtensionsControl.createContext(dc, pageContext, guiContext, bioAssay);
	ExtensionsInvoker invoker = ToolbarUtil.useExtensions(jspContext);
	%>
	<base:page title="<%=title%>">
	<base:head scripts="table.js,tabcontrol.js" styles="table.css,toolbar.css,headertabcontrol.css,path.css">
		<ext:scripts context="<%=jspContext%>" />
		<ext:stylesheets context="<%=jspContext%>" />
		<script language="JavaScript">
		function editItem()
		{
			Main.viewOrEditItem('<%=ID%>', '<%=itemType.name()%>', <%=itemId%>, true);
		}
		function runPlugin(cmd)
		{
			Main.openPopup('index.jsp?ID=<%=ID%>&cmd='+cmd+'&item_id=<%=itemId%>', 'RunPlugin'+cmd, 740, 540);
		}
		function switchTab(tabControlId, tabId)
		{
			if (tabId == 'spotdata')
			{
				location.href = "../spotdata/index.jsp?ID=<%=ID%>&bioassay_id=<%=itemId%>";
			}
			else
			{
				TabControl.setActiveTab(tabControlId, tabId);
			}
		}
		function openPlotTool()
		{
			Main.openPopup('../plotter/index.jsp?ID=<%=ID%>&bioassay_id=<%=itemId%>', 'Plotter', 1000, 700);
		}
		</script>
	</base:head>
	<base:body>
		<p>
		<p:path>
			<p:pathelement title="Experiments" href="<%="../index.jsp?ID="+ID%>" />
			<p:pathelement title="<%=HTML.encodeTags(experiment.getName())%>" 
				href="<%="../bioassaysets/index.jsp?ID="+ID+"&experiment_id="+experiment.getId()%>" />
			<p:pathelement title="<%=HTML.encodeTags(bioAssaySet.getName())%>" 
				href="<%="index.jsp?ID="+ID+"&bioassayset_id="+bioAssaySet.getId()%>" />
			<p:pathelement title="<%=HTML.encodeTags(bioAssay.getName())%>" />
		</p:path>

		<t:tabcontrol id="main" active="<%=tabId%>" switch="switchTab">
		<t:tab id="properties" title="Properties">
		<tbl:toolbar
			>
			<tbl:button 
				disabled="<%=writePermission ? false : true%>" 
				image="<%=writePermission ? "edit.gif" : "edit_disabled.gif"%>" 
				onclick="editItem()" 
				title="Edit&hellip;" 
				tooltip="<%=writePermission ? "Edit this bioassay" : "You do not have permission to edit this bioassay"%>" 
			/>
			<tbl:button 
				image="import.gif" 
				onclick="runPlugin('ImportItem')" 
				title="Import&hellip;" 
				tooltip="Import data" 
				visible="<%=pluginCount.containsKey(Plugin.MainType.IMPORT)%>"
			/>
			<tbl:button 
				image="export.gif" 
				onclick="runPlugin('ExportItem')" 
				title="Export&hellip;" 
				tooltip="Export data" 
				visible="<%=pluginCount.containsKey(Plugin.MainType.EXPORT)%>"
			/>
			<tbl:button 
				image="runplugin.gif" 
				onclick="runPlugin('RunPlugin')" 
				title="Run plugin&hellip;" 
				tooltip="Run a plugin" 
				visible="<%=pluginCount.containsKey(Plugin.MainType.OTHER)%>"
			/>
			<tbl:button
				image="plotter.gif"
				onclick="openPlotTool()"
				title="Plot tool&hellip;"
				tooltip="A simple tool for generating plots"
				visible="<%=hasDbSpots%>"
			/>
			<ext:render extensions="<%=invoker%>" context="<%=jspContext%>" 
				wrapper="<%=new PrefixSuffixRenderer(jspContext, "<td>", "</td>") %>"/>
			<tbl:button
				image="help.gif"
				onclick="<%="Main.openHelp('" + ID +"', 'bioassay.view.properties')"%>"
				title="Help&hellip;"
				tooltip="Get help about this page"
			/>
			</tbl:toolbar>
			
		<div class="boxedbottom">
			<div class="itemstatus">Permissions on this item: <i><%=PermissionUtil.getFullPermissionNames(bioAssay)%></i></div>
			<table class="form" cellspacing=0>
			<tr>
				<td class="prompt">Name</td>
				<td><%=HTML.encodeTags(bioAssay.getName())%></td>
			</tr>
			<tr>
				<td class="prompt">Spots</td>
				<td>db: <%=bioAssay.getNumSpots()%>; file: <%=bioAssay.getNumFileSpots()%></td>
			</tr>
			<tr valign=top>
				<td class="prompt">Description</td>
				<td><%=HTML.encodeTags(bioAssay.getDescription())%></td>
			</tr>
			</table>

			<jsp:include page="../../../common/datafiles/list_files.jsp">
				<jsp:param name="item_type" value="BIOASSAYSET" />
				<jsp:param name="item_id" value="<%=bioAssaySet.getId()%>" />
				<jsp:param name="ID" value="<%=ID%>" />
			</jsp:include>
		
			<%
			ItemQuery<RawBioAssay> rawQuery = bioAssay.getRawBioAssays();
			rawQuery.include(Include.MINE, Include.SHARED, Include.OTHERS, Include.IN_PROJECT);
			rawQuery.order(Orders.asc(Hql.property("name")));
			ItemResultList<RawBioAssay> rawBioAssays = rawQuery.list(dc);
			if (rawBioAssays.size() == 0)
			{
				%>
				<h4>Raw bioassays</h4>
				No raw bioassays are linked to this bioassay
				(or, you don't have permission to view them).
				<%
			}
			else
			{
				%>
				<h4 class="docked">Raw bioassays</h4>
				<tbl:table
					id="rawBioAssays"
					clazz="itemlist"
					columns="all"
					>
				<tbl:columndef 
					id="name"
					title="Name"
				/>
				<tbl:columndef
					id="spots"
					title="Spots"
				/>
				<tbl:columndef 
					id="description"
					title="Description"
				/>
				<%
				ItemQuery<AnnotationType> efQuery = experiment.getExperimentalFactors();
				efQuery.include(Include.ALL);
				efQuery.order(Orders.asc(Hql.property("name")));
				ItemResultList<AnnotationType> experimentalFactors = efQuery.list(dc);
				for (AnnotationType at : experimentalFactors)
				{
					Formatter formatter = FormatterFactory.getTypeFormatter(sc, at.getValueType());
					%>
					<tbl:columndef
						id="<%="at"+at.getId()%>"
						title="<%=HTML.encodeTags(at.getName())%>"
						formatter="<%=formatter%>"
					/>
					<%
				}
				%>
				<tbl:data>
					<tbl:columns>
					</tbl:columns>
					<tbl:rows>
					<%
					for (RawBioAssay item : rawBioAssays)
					{
						%>
						<tbl:row>
							<tbl:cell column="name"><%=Base.getLinkedName(ID, item, false, true)%></tbl:cell>
							<tbl:cell column="spots"><%=item.getSpots()%></tbl:cell>
							<tbl:cell column="description"><%=HTML.encodeTags(item.getDescription())%></tbl:cell>
							<%
							AnnotationSet as = item.isAnnotated() ? item.getAnnotationSet() : null;
							for (AnnotationType at : experimentalFactors)
							{
								String value = "<i>- none -</i>";
								List<Annotation> all = as == null ? null : as.findAnnotations(dc, at, true);
								Map<Annotatable, List> factorValues = new HashMap<Annotatable, List>();
								if (all != null && all.size() > 0)
								{
									for (Annotation a : all)
									{
										List values = a.getValues();
										Annotatable aItem = null;
										try
										{
											aItem = a.getAnnotationSet().getItem();
										}
										catch (Throwable t)
										{}
										List toAdd = factorValues.get(aItem);
										if (toAdd == null)
										{
											toAdd = new LinkedList();
											factorValues.put(aItem, toAdd);
										}
										toAdd.addAll(values);
									}
								}
								%>
								<tbl:cell column="<%="at"+at.getId()%>"
									>
									<%
									for (Map.Entry<Annotatable, List> entry : factorValues.entrySet())
									{
										Annotatable aItem = entry.getKey();
										List values = entry.getValue();
										%>
										<tbl:cellvalue list="<%=values%>" />
										<%
										if (aItem != null && aItem.hasPermission(Permission.WRITE))
										{
											%>: <base:icon image="edit.gif" 
												onclick="<%="editInheritedAnnotation('"+aItem.getType().name()+"',"+aItem.getId()+","+at.getId()+")"%>" 
												tooltip="Modify the values of this experimental factor" />
											<%
										}
									}
									%>
								</tbl:cell>
								<%
							}
							%>
						</tbl:row>
						<%
					}
					%>
					</tbl:rows>
				</tbl:data>
				</tbl:table>
				<%
			}
			%>
		</div>
		</t:tab>
		
		<t:tab id="annotations" title="Annotations" 
			tooltip="View annotation values">
			<div class="boxed">
			<jsp:include page="../../../common/annotations/list_annotations.jsp">
				<jsp:param name="item_type" value="<%=itemType.name()%>" />
				<jsp:param name="item_id" value="<%=itemId%>" />
				<jsp:param name="ID" value="<%=ID%>" />
			</jsp:include>
			</div>
		</t:tab>

		<t:tab id="spotdata" title="Spot data" visible="<%=hasDbSpots%>" />
		
		</t:tabcontrol>


	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
%>
