<%@page import="net.sf.basedb.core.FeatureIdentificationMethod"%>
<%-- $Id: index.jsp 4901 2009-04-23 13:57:52Z martin $
	------------------------------------------------------------------
	Copyright (C) 2005 Nicklas Nordborg
	Copyright (C) 2006 Jari Hkkinen, Nicklas Nordborg, Martin Svensson
	Copyright (C) 2007 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
	@version 2.0
--%>
<%@ page session="false"
	import="net.sf.basedb.core.Application"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.Include"
	import="net.sf.basedb.core.RawBioAssay"
	import="net.sf.basedb.core.Affymetrix"
	import="net.sf.basedb.core.Scan"
	import="net.sf.basedb.core.Protocol"
	import="net.sf.basedb.core.Software"
	import="net.sf.basedb.core.ArrayDesign"
	import="net.sf.basedb.core.Experiment"
	import="net.sf.basedb.core.File"
	import="net.sf.basedb.core.FileType"
	import="net.sf.basedb.core.RawDataType"
	import="net.sf.basedb.core.RawDataTypes"
	import="net.sf.basedb.core.Platform"
	import="net.sf.basedb.core.PlatformVariant"
	import="net.sf.basedb.core.User"
	import="net.sf.basedb.core.Path"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.ItemResultIterator"
	import="net.sf.basedb.core.OwnedItem"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.MultiPermissions"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.core.ItemAlreadyExistsException"
	import="net.sf.basedb.core.PluginDefinition"
	import="net.sf.basedb.core.Job"
	import="net.sf.basedb.core.ProgressReporter"
	import="net.sf.basedb.core.IntegerParameterType"
	import="net.sf.basedb.core.FloatParameterType"
	import="net.sf.basedb.core.StringParameterType"
	import="net.sf.basedb.core.FileParameterType"
	import="net.sf.basedb.core.ItemParameterType"
	import="net.sf.basedb.core.BooleanParameterType"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.core.query.Restrictions"
	import="net.sf.basedb.core.query.Expressions"
	import="net.sf.basedb.util.RemovableUtil"
	import="net.sf.basedb.util.ShareableUtil"
	import="net.sf.basedb.util.OwnableUtil"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.WebException"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.util.formatter.NameableFormatter"
	import="net.sf.basedb.clients.web.plugins.ItemQueryLoader"
	import="net.sf.basedb.clients.web.util.HTML"	
	import="java.util.Enumeration"
	import="java.util.Set"
	import="java.util.HashSet"
	import="java.util.List"
	import="java.util.ArrayList"
	import="java.util.Arrays"
	import="java.util.Collections"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%!
	private static final ItemContext defaultContext = Base.createDefaultContext("name", "name,platform,variant,hasData,description");
	private static final Item itemType = Item.RAWBIOASSAY;
	
	private static void registerExportUtils(ItemContext cc)
	{
		// Register formatters
		cc.setObject("export.formatter.&experiments(name)", new NameableFormatter());
		
		// Register dataloaders
		String rawParameter = "rawBioAssay";
		final ItemQuery<Experiment> experimentQuery = Experiment.getQuery();
		experimentQuery.include(cc.getInclude());
		experimentQuery.join(Hql.innerJoin("rawBioAssays", "rba"));
		experimentQuery.restrict(Restrictions.eq(Hql.alias("rba"), Expressions.parameter(rawParameter)));
		experimentQuery.order(Orders.asc(Hql.property("name"))); 
		cc.setObject("export.dataloader.&experiments(name)", new ItemQueryLoader(experimentQuery, rawParameter));
	}
	
	private static class UpdateArrayDesign
		implements Runnable
	{
		private final int jobId;
		private final int rawBioAssayId;
		private final int arrayDesignId;
		private final SessionControl sc;
		private final FeatureIdentificationMethod fiMethod;
		
		private UpdateArrayDesign(Job job, RawBioAssay rba, ArrayDesign design, FeatureIdentificationMethod fiMethod)
		{
			this.jobId = job.getId();
			this.rawBioAssayId = rba.getId();
			this.arrayDesignId = design.getId();
			this.sc = job.getSessionControl();
			this.fiMethod = fiMethod;
		}
		
		public void run()
		{
			DbControl dc = sc.newDbControl();
			try
			{
				Job j = Job.getById(dc, jobId);
				j.start("Initialising...", Application.getHostName());
				ProgressReporter progress = j.getProgressReporter(null);
				dc.commit();
				dc = sc.newDbControl();
				RawBioAssay rba = RawBioAssay.getById(dc, rawBioAssayId);
				ArrayDesign design = ArrayDesign.getById(dc, arrayDesignId);
				try
				{
					rba.updateArrayDesign(design, fiMethod, progress);
					progress.display(99, "Committing changes to database...");
					dc.commit();
					dc = sc.newDbControl();
					j = Job.getById(dc, jobId);
					j.doneOk("Array design updated successfully");
					j.setRemoved(true);
					dc.commit();
				}
				catch (Throwable t)
				{
					if (dc != null) dc.close();
					dc = sc.newDbControl();
					j = Job.getById(dc, jobId);
					j.doneError(t.getMessage(), Arrays.asList(t));
					j.setRemoved(true);
					dc.commit();
				}
			}
			finally
			{
				if (dc != null) dc.close();
			}
		}
	}
%>
<%
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final String ID = sc.getId();
final String cmd = request.getParameter("cmd");
final String root = request.getContextPath()+"/";
final String mode = request.getParameter("mode");
final String callback = request.getParameter("callback");
final String itemId = request.getParameter("item_id");
final String listPage = "list_rawbioassays.jsp?ID="+ID
	+(mode == null ? "" : "&mode="+mode)
	+(callback == null ? "" : "&callback="+callback)
	+(itemId == null ? "" : "&item_id="+itemId);
final String viewPage = "view_rawbioassay.jsp?ID="+ID;
final String editPage = "edit_rawbioassay.jsp?ID="+ID;

String forward = null;
String redirect = null;
String message = null;
DbControl dc = null;

try
{
	if (cmd == null || "List".equals(cmd))
	{
		// Display the list page without updatinging the current context
		Base.getAndSetCurrentContext(sc, itemType, null, defaultContext, true);
		redirect = listPage;
	}
	else if ("UpdateContext".equals(cmd))
	{
		// Display the list page after updating the current context from the request parameters
		Base.getAndSetCurrentContext(sc, itemType, pageContext, defaultContext);
		redirect = listPage;
	}
	else if ("LoadContext".equals(cmd))
	{
		// Display the list page after loading a saved context
		int contextId = Values.getInt(request.getParameter("context"));
		Base.loadContext(sc, contextId, defaultContext);
		redirect = listPage;
	}

	else if ("ViewItem".equals(cmd))
	{
		// Display the view page for a single item 
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, pageContext, defaultContext);
		forward = viewPage;
	}
	else if ("EditItem".equals(cmd))
	{
		// Display the edit page for a single item (should be opened in a popup)
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, pageContext, defaultContext);
		forward = editPage;
	}
	else if ("EditSpotImages".equals(cmd))
	{
		// Display the spot images edit page for a single item (should be opened in a popup)
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, pageContext, defaultContext);
		redirect = "edit_spotimages.jsp?ID="+ID;
	}
	else if ("NewItem".equals(cmd))
	{
		// Display the edit page for a new item (should be opened in a popup)
		if (!sc.hasPermission(Permission.CREATE, itemType))
		{
			throw new PermissionDeniedException(Permission.CREATE, itemType.toString());
		}
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, pageContext, defaultContext);
		cc.setId(0);
		forward = editPage;
	}
	else if ("UpdateItem".equals(cmd))
	{
		// Update the properties on an item (will close the popup)
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, null, defaultContext);
		final int maxRecent = Base.getMaxRecent(sc);
		dc = sc.newDbControl();
		RawBioAssay rba = (RawBioAssay)cc.getObject("item");
		
		Platform platform = null;
		PlatformVariant variant = null;

		if (request.getParameter("platform") != null)
		{
			String[] pv = request.getParameter("platform").split(":");
			int platformId = Values.getInt(pv[0], -1);
			int variantId = pv.length > 1 ? Values.getInt(pv[1], -1) : -1;
			if (platformId > 0) platform =  Platform.getById(dc, platformId);
			if (variantId > 0) variant = PlatformVariant.getById(dc, variantId);
		}
		RawDataType rdt = RawDataTypes.getRawDataType(Values.getStringOrNull(request.getParameter("rawdatatype")));
		if (platform != null) cc.setRecent(platform, maxRecent);
		if (variant != null) cc.setRecent(variant, maxRecent);
		if (rdt != null) cc.setRecent("RawDataType", rdt.getId(), maxRecent);

		if (rba == null)
		{
			if (variant != null)
			{
				rba = RawBioAssay.getNew(dc, variant, rdt);
			}
			else
			{
				rba = RawBioAssay.getNew(dc, platform, rdt);
			}
			message = "Raw bioassay created";
			dc.saveItem(rba);
		}
		else
		{
			dc.reattachItem(rba);
			if (variant != null)
			{
				rba.setVariant(variant, rdt);
			}
			else if (platform != null)
			{
				rba.setPlatform(platform, rdt);
			}
			message = "Raw bioassay updated";
		}
		rba.setName(Values.getStringOrNull(request.getParameter("name")));
		rba.setDescription(Values.getStringOrNull(request.getParameter("description")));
		rba.setArrayNum(Values.getInt(request.getParameter("arrayNum"), 1));
		int protocolId = Values.getInt(request.getParameter("protocol_id"), -1);
		if (protocolId >= 0)  // < 0 = denied or unchanged
		{
			Protocol pt = protocolId == 0 ? null : Protocol.getById(dc, protocolId);
			rba.setProtocol(pt);
			if (pt != null) cc.setRecent(pt, maxRecent);
		}
		int softwareId = Values.getInt(request.getParameter("software_id"), -1);
		if (softwareId >= 0) // < 0 = denied or unchanged
		{
			Software sw = softwareId == 0 ? null : Software.getById(dc, softwareId);
			rba.setSoftware(sw);
			if (sw != null) cc.setRecent(sw, maxRecent);
		}
		int scanId = Values.getInt(request.getParameter("scan_id"), -1);
		if (scanId >= 0) // < 0 = denied or unchanged
		{
			Scan scan = scanId == 0 ? null : Scan.getById(dc, scanId);
			rba.setScan(scan);
			if (scan != null) cc.setRecent(scan, maxRecent);
		}
		Job job = null;
		ArrayDesign ad = null;
		FeatureIdentificationMethod fiMethod = null;
		int arrayDesignId = Values.getInt(request.getParameter("arraydesign_id"), -1);
		if (arrayDesignId >= 0) // < 0 = denied or unchanged
		{
			ad = arrayDesignId == 0 ? null : ArrayDesign.getById(dc, arrayDesignId);
			if (rba.hasData())
			{
				try
				{
					fiMethod = FeatureIdentificationMethod.valueOf(request.getParameter("fiMethod"));
				}
				catch (Exception ex)
				{}
				if (rba.getRawDataType().isStoredInDb() && ad != null && ad.hasFeatures())
				{
					// Create job and assign it to another thread
					job = Job.getNew(dc, null, null);
					job.setName("Validating array design on " + rba.getName());
					job.setPrepared(Application.getHostName());
					job.setSendMessage(Values.getBoolean(sc.getUserClientSetting("plugins.sendmessage"), false));
					dc.saveItem(job);
				}
				else
				{
					rba.updateArrayDesign(ad, fiMethod, null);
				}
			}
			else
			{
				rba.setArrayDesign(ad);
			}
			if (ad != null) cc.setRecent(ad, maxRecent);
		}

		// Data files tab
		boolean validate = Values.getBoolean(request.getParameter("datafiles.validate"));
		boolean metadata = Values.getBoolean(request.getParameter("datafiles.metadata"));
		Base.updateFiles(dc, rba, request, validate, metadata, cc, maxRecent);
		
		// Annotations tab
		Base.updateAnnotations(dc, rba, rba, request);
		dc.commit();
		cc.removeObject("item");
		if (job != null) 
		{
			redirect = "../jobs/index.jsp?ID="+ID+"&cmd=ViewItem&item_id="+job.getId();
			Thread updateThread = new Thread(new UpdateArrayDesign(job, rba, ad, fiMethod));
			updateThread.setPriority(Thread.currentThread().getPriority() - 1);
			updateThread.start();
		}
	}
	else if ("DeleteItem".equals(cmd))
	{
		// Delete a single item and then return to the view page
		dc = sc.newDbControl();
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, pageContext, defaultContext);
		RemovableUtil.setRemoved(dc, itemType, Collections.singleton(cc.getId()), true);
		dc.commit();
		redirect = viewPage;
	}
	else if ("DeleteItems".equals(cmd))
	{
		// Delete all selected items on the list page
		dc = sc.newDbControl();
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, pageContext, defaultContext);
		int numTotal = cc.getSelected().size();
		int numRemoved = RemovableUtil.setRemoved(dc, itemType, cc.getSelected(), true);
		dc.commit();
		if (numTotal != numRemoved)
		{
			message = (numRemoved == 0 ? "No" : "Only "+numRemoved+" of "+numTotal) + " items could be deleted, because you have no DELETE permission";
		}
		redirect = listPage+(message != null ? "&popmessage="+HTML.urlEncode(message) : "");
	}
	else if ("RestoreItem".equals(cmd))
	{
		// Restore a single item and then return to the view page
		dc = sc.newDbControl();
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, pageContext, defaultContext);
		RemovableUtil.setRemoved(dc, itemType, Collections.singleton(cc.getId()), false);
		dc.commit();
		redirect = viewPage;
	}
	else if ("RestoreItems".equals(cmd))
	{
		// Restore all selected items on the list page
		dc = sc.newDbControl();
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, pageContext, defaultContext);
		int numTotal = cc.getSelected().size();
		int numRemoved = RemovableUtil.setRemoved(dc, itemType, cc.getSelected(), false);
		dc.commit();
		if (numTotal != numRemoved)
		{
			message = (numRemoved == 0 ? "No" : "Only "+numRemoved+" of "+numTotal) + " items could be restored, because you have no WRITE permission";
		}
		redirect = listPage+(message != null ? "&popmessage="+HTML.urlEncode(message) : "");
	}
	else if ("ShareItem".equals(cmd))
	{
		// Display a popup window for sharing a single item
		dc = sc.newDbControl();
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, pageContext, defaultContext);
		MultiPermissions permissions = ShareableUtil.getMultiPermissions(dc, itemType, Collections.singleton(cc.getId()));
		dc.close();
		cc.setObject("MultiPermissions", permissions);
		redirect = "../../common/share/share.jsp?ID="+ID+"&item_type="+itemType.name();
	}
	else if ("ShareItems".equals(cmd))
	{
		// Display a popup window for sharing all selected items on the list page
		dc = sc.newDbControl();
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, pageContext, defaultContext);
		MultiPermissions permissions = ShareableUtil.getMultiPermissions(dc, itemType, cc.getSelected());
		dc.close();
		cc.setObject("MultiPermissions", permissions);
		redirect = "../../common/share/share.jsp?ID="+ID+"&item_type="+itemType.name();
	}
	else if ("SetOwnerOfItem".equals(cmd))
	{
		// Change owner of items selected on a list page
		dc = sc.newDbControl();
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, pageContext, defaultContext);
		OwnedItem item = (OwnedItem)itemType.getById(dc, cc.getId());
		cc.setObject("OwnedItems", Collections.singleton(item));
		redirect = "../../common/ownership/ownership.jsp?ID="+ID+"&item_type="+itemType.name();
	}
	else if ("SetOwnerOfItems".equals(cmd))
	{
		// Change owner of items selected on a list page
		dc = sc.newDbControl();
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, pageContext, defaultContext);
		Set<OwnedItem> items = new HashSet<OwnedItem>();
		for (Integer id : cc.getSelected())
		{
			if (id != null) items.add((OwnedItem)itemType.getById(dc, id));
		}
		dc.close();
		cc.setObject("OwnedItems", items);
		redirect = "../../common/ownership/ownership.jsp?ID="+ID+"&item_type="+itemType.name();
	}
	else if ("ExportItems".equals(cmd))
	{
		// Run an export plugin in a list context
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, pageContext, defaultContext);
		final ItemQuery<RawBioAssay> query = RawBioAssay.getQuery();
		cc.configureQuery(query, true);
		cc.setQuery(query);
		registerExportUtils(cc);
		redirect = "../../common/export/index.jsp?ID="+ID+"&cmd=SelectPlugin&item_type="+itemType.name()+"&context_type=LIST&title=Export+raw+bioassays";
	}
	else if ("ExportItem".equals(cmd))
	{
		// Run an export plugin in single-item context
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, pageContext, defaultContext);
		registerExportUtils(cc);
		redirect = "../../common/export/index.jsp?ID="+ID+"&cmd=SelectPlugin&item_type="+itemType.name()+"&context_type=ITEM&title=Export+raw+bioassay";
	}
	else if ("ImportItems".equals(cmd))
	{
		// Run an import plugin in a list context
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, pageContext, defaultContext);
		final ItemQuery<RawBioAssay> query = RawBioAssay.getQuery();
		cc.configureQuery(query, true);
		cc.setQuery(query);
		redirect = "../../common/import/index.jsp?ID="+ID+"&cmd=SelectPlugin&item_type="+itemType.name()+"&context_type=LIST&title=Import+raw+bioassays";
	}
	else if ("ImportItem".equals(cmd))
	{
		// Run an import plugin in single-item context
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, pageContext, defaultContext);
		// Set file type filter
		ItemContext fileContext = sc.getCurrentContext(Item.FILE);
		fileContext.setPropertyFilter(FileType.getPropertyFilter(FileType.RAW_DATA));
		redirect = "../../common/import/index.jsp?ID="+ID+"&cmd=SelectPlugin&item_type="+itemType.name()+"&context_type=ITEM&title=Import+raw+bioassay";
	}
	else if ("RunListPlugin".equals(cmd))
	{
		// Run another plugin in a list context
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, pageContext, defaultContext);
		final ItemQuery<RawBioAssay> query = RawBioAssay.getQuery();
		cc.configureQuery(query, true);
		cc.setQuery(query);
		redirect = "../../common/plugin/index.jsp?ID="+ID+"&cmd=SelectPlugin&item_type="+itemType.name()+"&context_type=LIST&main_type=OTHER&title=Run+plugin";
	}
	else if ("RunPlugin".equals(cmd))
	{
		// Run another plugin in single-item context
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, pageContext, defaultContext);
		redirect = "../../common/plugin/index.jsp?ID="+ID+"&cmd=SelectPlugin&item_type="+itemType.name()+"&context_type=ITEM&main_type=OTHER&title=Run+plugin";
	}
	else if ("CreateSpotImages".equals(cmd))
	{
		dc = sc.newDbControl();
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, pageContext, defaultContext);
		RawBioAssay rba = RawBioAssay.getById(dc, cc.getId());
		
		int redFileId = Values.getInt(request.getParameter("redfile_id"));
		File red = redFileId == 0 ? null : File.getById(dc, redFileId);
		int greenFileId = Values.getInt(request.getParameter("greenfile_id"));
		File green = greenFileId == 0 ? null : File.getById(dc, greenFileId);
		int blueFileId = Values.getInt(request.getParameter("bluefile_id"));
		File blue = blueFileId == 0 ? null : File.getById(dc, blueFileId);

		String path = Values.getStringOrNull(request.getParameter("path"));
		if (path.startsWith("~/"))
		{
			User user = User.getById(dc, sc.getLoggedInUserId());
			path = "~"+user.getLogin()+path.substring(1);
		}
		Path p = new Path(path, Path.Type.FILE);
		File saveAs = File.getByPath(dc, p, true);
		if (saveAs.isInDatabase() && !Values.getBoolean(request.getParameter("overwrite")))
		{
			throw new ItemAlreadyExistsException("File[path="+path+"]");
		}
		
		IntegerParameterType integerParameter = new IntegerParameterType();
		FloatParameterType floatParameter = new FloatParameterType();
		FileParameterType fileParameter = new FileParameterType();
		ItemParameterType<RawBioAssay> itemParameter = new ItemParameterType(RawBioAssay.class, null);
		StringParameterType stringParameter = new StringParameterType();
		BooleanParameterType booleanParameter = new BooleanParameterType();
		
		PluginDefinition plugin = PluginDefinition.getByClassName(dc, "net.sf.basedb.plugins.SpotImageCreator");
		Job job = Job.getNew(dc, plugin, null);
		job.setName("Create spot images for raw bioassay: " + rba.getName());
		job.setParameterValue("rawBioAssay", "Raw bioassay", 
			"The raw bioassay to create spot images for", itemParameter, rba);
		job.setParameterValue("xScale", "X scale factor", 
			"The raw data X value will be divided by this value to get the pixel coordinate", 
			integerParameter, Values.getInt(request.getParameter("x_scale")));
		job.setParameterValue("yScale", "Y scale factor", 
			"The raw data Y value will be divided by this value to get the pixel coordinate", 
			integerParameter, Values.getInt(request.getParameter("y_scale")));
		job.setParameterValue("xOffset", "X offset value",
			"The offset is subtracted from the raw data X value",
			integerParameter, Values.getInt(request.getParameter("x_offset")));
		job.setParameterValue("yOffset", "Y offset value",
			"The offset is subtracted from the raw data Y value",
			integerParameter, Values.getInt(request.getParameter("y_offset")));
		job.setParameterValue("spotsize", "Spot size", "The size of each spot in pixels",
			integerParameter, Values.getInt(request.getParameter("spotsize")));
		job.setParameterValue("gamma", "Gamma", "Gamma correction for display",
			floatParameter, Values.getFloat(request.getParameter("gamma")));
		job.setParameterValue("quality", "Quality", 
			"The quality is a number between 0.0 and 1.0, with 1.0 indicating highest quality.", 
			floatParameter, Values.getFloat(request.getParameter("quality")));
		job.setParameterValue("redFile", "Red image", 
			"The file containing the image to use for the red part", fileParameter, red);
		job.setParameterValue("greenFile", "Green image", 
			"The file containing the image to use for the green part", fileParameter, green);
		job.setParameterValue("blueFile", "Blue image",
			"The file containing the image to use for the red part", fileParameter, blue);
		job.setParameterValue("path", "Save as", 
			"The file name where the spot images should be saved", stringParameter, path);
		job.setParameterValue("overwrite", "Overwrite", 
			"If an existing file should be overwritten or not", booleanParameter, Values.getBoolean(request.getParameter("overwrite")));
		
		dc.saveItem(job);
		dc.commit();

		redirect = "../jobs/index.jsp?ID="+ID+"&cmd=ViewItem&item_id="+job.getId();
	}
	else
	{
		throw new WebException("popup", "Invalid command", "The command {1} is not recognised as a valid command.", cmd);
	}


	/*
	else if ("ImportRawData".equals(cmd))
	{
		RawBioAssay rba = (RawBioAssay)sc.getSessionSetting(itemType.name()+".item");
		ItemContext context = sc.getCurrentContext(itemType);
		context.setId(rba.getId());
		redirect = "../../common/import/configure.jsp?ID="+ID+"&item_type="+itemType.name()+"&context_type=ITEM&title=Import+raw+data+for+"+HTML.urlEncode(rba.getName());

	}
	*/
}
finally
{
	if (dc != null) dc.close();
}

if (forward != null)
{
	pageContext.forward(forward);
}
else if (redirect != null)
{
	response.sendRedirect(redirect);
}
else if (message == null)
{
	response.sendRedirect(root + "common/close_popup.jsp?refresh_opener=1&wait=0");
}
else
{
	response.sendRedirect(root + "common/close_popup.jsp?refresh_opener=1&message="+HTML.urlEncode(message));
}
%>

